/*
 *   Copyright (C) 2003 by Jonathan Naylor G4KLX/HB9DRD
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "NCO.h"

#include <cmath>
using namespace std;

#include <wx/log.h>
#include <wx/debug.h>

CNCO::CNCO(int rate, int length) :
m_rate(rate),
m_length(length),
m_dds(0.0)
{
	wxASSERT(m_rate > 0);
	wxASSERT(length > 0);

	m_data = new double[m_length];
}

CNCO::~CNCO()
{
	delete[] m_data;
}

double* CNCO::generate(double frequency)
{
	double ddsInc = (::fabs(frequency) * 2.0 * M_PI) / double(m_rate);

	for (int i = 0; i < m_length; i++) {
		m_data[i] = ::sin(m_dds);

		m_dds += ddsInc;
	}

	return m_data;
}
