/*
 *   Copyright (C) 2002,2003 by Jonathan Naylor G4KLX/HB9DRD
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "common/SoundFile.h"

#include "jt44/JT44Defs.h"

#include "AudioData.h"

int main(int argc, char **argv)
{
	if (argc < 2) {
		::fprintf(stderr, "Usage: AudioData <filename>\n");
		return 1;
	}

	wxString fileName = wxString(argv[1]);

	CAudioData speed(fileName);
	speed.run();

	return 0;
}

CAudioData::CAudioData(const wxString& fileName) :
m_fileName(fileName),
m_data()
{
}

CAudioData::~CAudioData()
{
}

void CAudioData::run()
{
	CSoundDev* file = new CSoundFile;

	file->openRead(m_fileName, JT44_SAMPLE_RATE, 16);

	double* in = new double[4096];

	for (;;) {
		int len = 4096;
		if (!file->read(in, len))
			break;

		for (int i = 0; i < len; i++)
			m_data.addValue(in[i]);
	}

	file->close();

	delete file;
	delete[] in;

	printf("Samples: %d Min/Ave/Max: %f/%f/%f\n", m_data.getCount(),
		m_data.getMinimum(),
		m_data.getAverage(),
		m_data.getMaximum());
}
