/*
 *   Copyright (C) 2002,2003 by Jonathan Naylor G4KLX/HB9DRD
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	FSK441Decoder2_H
#define	FSK441Decoder2_H

#include <wx/string.h>

#include "common/Average.h"

class CFSK441Decoder2 {

    public:
	CFSK441Decoder2(const wxString& fileName, double ratio, int n);
	~CFSK441Decoder2();

	void run();

    private:
	wxString  m_fileName;
	double    m_ratio;
	int       m_n;
	double    m_lastCorrVal;
	int       m_lastSymbol;
	int       m_corrCount;
	int       m_startTime;
	bool      m_found;
	CAverage  m_noise;
	CAverage  m_levels;
	wxString* m_data;

	bool correlate(double v0, double v1, double v2, double v3, double& c0, double& c1, double& c2, double& c3) const;
	int  seekBurst(int tim, double v0, double v1, double v2, double v3);
	int  lockBurst(int tim, double v0, double v1, double v2, double v3);
	int  storeBurst(int tim, double v0, double v1, double v2, double v3);
	void decodeBurst() const;
	wxString indexToSymbol(int n) const;
};

#endif
